## geany 0.17-1~bpo50+1

=== wscript ===
--- 
+++ 
@@ -20,7 +20,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
-# $Id: wscript 3534 2009-02-01 19:14:50Z eht16 $
+# $Id: wscript 3716 2009-04-21 20:52:19Z eht16 $
 
 """
 This is a WAF build script (http://code.google.com/p/waf/).
@@ -45,20 +45,21 @@
 
 
 APPNAME = 'geany'
-VERSION = '0.16'
+VERSION = '0.17'
 
 srcdir = '.'
 blddir = '_build_'
 
 
 tagmanager_sources = [
-	'tagmanager/args.c', 'tagmanager/asm.c', 'tagmanager/basic.c', 'tagmanager/c.c',
+	'tagmanager/args.c', 'tagmanager/actionscript.c', 'tagmanager/asm.c',
+	'tagmanager/basic.c', 'tagmanager/c.c',
 	'tagmanager/conf.c', 'tagmanager/css.c', 'tagmanager/ctags.c', 'tagmanager/diff.c',
 	'tagmanager/docbook.c', 'tagmanager/entry.c', 'tagmanager/fortran.c', 'tagmanager/get.c',
 	'tagmanager/haskell.c', 'tagmanager/haxe.c', 'tagmanager/html.c', 'tagmanager/js.c',
 	'tagmanager/keyword.c', 'tagmanager/latex.c', 'tagmanager/lregex.c', 'tagmanager/lua.c',
-	'tagmanager/make.c', 'tagmanager/matlab.c', 'tagmanager/options.c', 'tagmanager/parse.c',
-	'tagmanager/pascal.c',
+	'tagmanager/make.c', 'tagmanager/matlab.c', 'tagmanager/nsis.c', 'tagmanager/options.c',
+	'tagmanager/parse.c', 'tagmanager/pascal.c',
 	'tagmanager/perl.c', 'tagmanager/php.c', 'tagmanager/python.c', 'tagmanager/read.c',
 	'tagmanager/rest.c', 'tagmanager/ruby.c', 'tagmanager/sh.c', 'tagmanager/sort.c',
 	'tagmanager/sql.c', 'tagmanager/strlist.c', 'tagmanager/tcl.c', 'tagmanager/tm_file_entry.c',
@@ -279,5 +280,3 @@
 	bld.new_task_gen(
 		features		= 'cc cstaticlib',
 		source			= tagmanager_sources,
-		name			= 'tagmanager',
-		target			= 'tagmanager',
