=== debian/changelog ===
geany (0.17-1~bpo50+1) lenny-backports; urgency=low

  * New upstream release
  * 20_add_debdiff_as_diff_type.dpatch renamed as
    20_add_debian_specific_filetypes.dpatch, 
    - add .dpatch as a diff filetype
    - add control as a conf filetype
  * 20_change_gpl_location.dpatch freshen
  * add 20_debian_control_tags.dpatch better handling of debian/control files.
    Thanks to Enrico Tröger. (Closes: #520776)
  * debian/copyright Add Frank Lanitz, update years

 -- Damián Viano <des@debian.org>  Fri, 29 May 2009 21:22:54 -0300

geany (0.15-1) experimental; urgency=low

  * New upstream release
    - Allow loading projects from command line (Closes: #498854)
    - Fix a problem disabling the save icon inappropriately (Closes: #482875)
    - Detect makefiles from shebang and force using tabs
      for their indentation (Closes: #481198)
  * Remove Apps from doc-base section
  * Change homepage and related links to the new www.geany.org official domain

 -- Damián Viano <des@debian.org>  Sun, 26 Oct 2008 19:44:46 -0200

geany (0.14-1) unstable; urgency=low

  * New upstream release (Closes: #478126)

 -- Damián Viano <des@debian.org>  Fri, 02 May 2008 11:37:45 -0300

geany (0.13-1) unstable; urgency=low

  * New upstream release
    - Add filebrowser plugin (Closes: #440978)

 -- Damián Viano <des@debian.org>  Sat, 16 Feb 2008 19:27:19 -0200

geany (0.12-2) unstable; urgency=low

  * Add 20_add_debdiff_as_diff_type to recognize .debdiff files as diffs
    (Closes: #453516)

 -- Damián Viano <des@debian.org>  Wed, 05 Dec 2007 16:47:02 -0300

geany (0.12-1) unstable; urgency=low

  * New upstream release
    - Updates scintilla component (Closes: #438876, #426766)
    - Add mimetype declaration in the .desktop file (Closes: #416620)
  * Add intltool to Build-Depends

 -- Damián Viano <des@debian.org>  Mon, 29 Oct 2007 18:24:05 -0300

geany (0.11-2) unstable; urgency=low

  * Add versioned dependency against libgtk2.0-dev since geany code depends on
    it for notebook dnd at the moment

 -- Damián Viano <des@debian.org>  Mon, 11 Jun 2007 14:47:31 -0300

geany (0.11-1) unstable; urgency=low

  * New upstream release

 -- Damián Viano <des@debian.org>  Thu, 24 May 2007 07:15:52 -0300

geany (0.10.2-3) unstable; urgency=low

  * Change suggests to newer libvte, thanks to Andreas Tscharner (Closes: #421568)

 -- Damián Viano <des@debian.org>  Mon, 30 Apr 2007 20:17:06 -0300

geany (0.10.2-2) unstable; urgency=low

  * Upload to get geany 0.10.2 into sid
  * Change maintainer mail address

 -- Damián Viano <des@debian.org>  Sat, 28 Apr 2007 08:34:00 -0300

geany (0.10.2-1) experimental; urgency=low

  * New upstream release

 -- Damián Viano <debian@damianv.com.ar>  Sun, 25 Feb 2007 16:39:56 -0300

geany (0.10.1-1) unstable; urgency=low

  * New upstream release

 -- Damián Viano <debian@damianv.com.ar>  Sun, 25 Feb 2007 15:31:13 -0300

geany (0.10-1) unstable; urgency=low

  * New upstream release

 -- Damián Viano <debian@damianv.com.ar>  Sun, 24 Dec 2006 12:17:24 -0300

geany (0.9-1) unstable; urgency=low

  * New upstream release

 -- Damián Viano <debian@damianv.com.ar>  Fri, 29 Sep 2006 06:13:18 -0300

geany (0.8-1) unstable; urgency=low

  * New upstream release
    - Fixed clipboard commands used in the find entry and Scribble (Closes: #377060)
    - Don't autocomplete constructs inside a string (Closes: #377090)

 -- Damián Viano <debian@damianv.com.ar>  Wed,  9 Aug 2006 19:35:11 -0300

geany (0.7.1-1) unstable; urgency=low

  * New upstream release
    - Added Scintilla license
  * debian/copyright: included Scintilla license and copyright

 -- Damián Viano <debian@damianv.com.ar>  Sun, 25 Jun 2006 12:10:13 -0300

geany (0.7-1) unstable; urgency=low

  * Initial release (Closes: #360760)

 -- Damián Viano <debian@damianv.com.ar>  Tue,  6 Jun 2006 12:54:23 -0300
