=== debian/control ===
Source: geany
Section: devel
Priority: optional
Maintainer: Damián Viano <des@debian.org>
Homepage: http://www.geany.org
Vcs-Svn: http://geany.svn.sourceforge.net/svnroot/geany/trunk/
Vcs-Browser: http://geany.svn.sourceforge.net/viewvc/geany/
Build-Depends: debhelper (>= 5.0.0), dpatch, libgtk2.0-dev (>= 2.10), libglib2.0-dev, libatk1.0-dev, libpango1.0-dev, intltool
Standards-Version: 3.8.1

Package: geany
Architecture: any
Depends: ${shlibs:Depends}
Suggests: libvte9, doc-base
Description: A fast and lightweight IDE
 Geany is a small and lightweight integrated development environment.
 It was developed to provide a small and fast IDE, which has only a
 few dependencies from other packages. It is using only the GTK2 toolkit
 and therefore you need only the GTK2 runtime libraries to run Geany.
 .
 The basic features of Geany are:
  - syntax highlighting
  - code completion
  - auto completion of constructs like if, for and while, XML and HTML
  - call tips
  - folding
  - many supported filetypes like C, Java, PHP, HTML, Python, Perl, Pascal
  - symbol lists
  - embedded terminal emulation
 .
