## geany 0.18

=== wscript ===
--- 
+++ 
@@ -20,7 +20,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
-# $Id: wscript 3716 2009-04-21 20:52:19Z eht16 $
+# $Id: wscript 4079 2009-08-13 21:59:33Z eht16 $
 
 """
 This is a WAF build script (http://code.google.com/p/waf/).
@@ -35,17 +35,26 @@
 Known issues: Dependency handling is buggy, e.g. if src/document.h is
 			  changed, depending source files are not rebuilt (maybe Waf bug).
 
-Requires WAF 1.5.3 and Python 2.4 (or later).
+The code of this file itself loosely follows PEP 8 with some exceptions 
+(line width 100 characters and some other minor things).
+
+Requires WAF 1.5.7 and Python 2.4 (or later).
 """
 
 
-import Build, Configure, Options, Utils
-import sys, os, shutil
+import Build
+import Configure
+import Options
+import Utils
+import sys
+import os
+import shutil
+import tempfile
 from distutils import version
 
 
 APPNAME = 'geany'
-VERSION = '0.17'
+VERSION = '0.18'
 
 srcdir = '.'
 blddir = '_build_'
@@ -58,7 +67,8 @@
 	'tagmanager/docbook.c', 'tagmanager/entry.c', 'tagmanager/fortran.c', 'tagmanager/get.c',
 	'tagmanager/haskell.c', 'tagmanager/haxe.c', 'tagmanager/html.c', 'tagmanager/js.c',
 	'tagmanager/keyword.c', 'tagmanager/latex.c', 'tagmanager/lregex.c', 'tagmanager/lua.c',
-	'tagmanager/make.c', 'tagmanager/matlab.c', 'tagmanager/nsis.c', 'tagmanager/options.c',
+	'tagmanager/make.c', 'tagmanager/markdown.c', 'tagmanager/matlab.c', 'tagmanager/nsis.c',
+	'tagmanager/nestlevel.c', 'tagmanager/options.c',
 	'tagmanager/parse.c', 'tagmanager/pascal.c',
 	'tagmanager/perl.c', 'tagmanager/php.c', 'tagmanager/python.c', 'tagmanager/read.c',
 	'tagmanager/rest.c', 'tagmanager/ruby.c', 'tagmanager/sh.c', 'tagmanager/sort.c',
@@ -72,15 +82,19 @@
 	'scintilla/CharClassify.cxx', 'scintilla/ContractionState.cxx', 'scintilla/Decoration.cxx',
 	'scintilla/DocumentAccessor.cxx', 'scintilla/Document.cxx', 'scintilla/Editor.cxx',
 	'scintilla/ExternalLexer.cxx',  'scintilla/Indicator.cxx',  'scintilla/KeyMap.cxx',
-	'scintilla/KeyWords.cxx', 'scintilla/LexAda.cxx', 'scintilla/LexAsm.cxx', 'scintilla/LexBash.cxx',
+	'scintilla/KeyWords.cxx',
+	'scintilla/LexAda.cxx', 'scintilla/LexAsm.cxx', 'scintilla/LexBash.cxx',
 	'scintilla/LexBasic.cxx', 'scintilla/LexCaml.cxx', 'scintilla/LexCmake.cxx', 'scintilla/LexCPP.cxx',
 	'scintilla/LexCrontab.cxx', 'scintilla/LexCSS.cxx', 'scintilla/LexD.cxx',
 	'scintilla/LexFortran.cxx', 'scintilla/LexHaskell.cxx', 'scintilla/LexHTML.cxx',
-	'scintilla/LexLua.cxx', 'scintilla/LexNsis.cxx', 'scintilla/LexOthers.cxx',
+	'scintilla/LexLua.cxx', 'scintilla/LexMarkdown.cxx', 'scintilla/LexMatlab.cxx',
+	'scintilla/LexNsis.cxx', 'scintilla/LexOthers.cxx',
 	'scintilla/LexPascal.cxx', 'scintilla/LexPerl.cxx', 'scintilla/LexPython.cxx',
-	'scintilla/LexR.cxx', 'scintilla/LexMatlab.cxx', 'scintilla/LexYAML.cxx',
+	'scintilla/LexR.cxx',
 	'scintilla/LexRuby.cxx', 'scintilla/LexSQL.cxx', 'scintilla/LexTCL.cxx',
-	'scintilla/LexVHDL.cxx', 'scintilla/LineMarker.cxx', 'scintilla/PlatGTK.cxx',
+	'scintilla/LexVHDL.cxx', 'scintilla/LexYAML.cxx',
+	'scintilla/LineMarker.cxx', 'scintilla/PerLine.cxx',
+	'scintilla/PlatGTK.cxx',
 	'scintilla/PositionCache.cxx', 'scintilla/PropSet.cxx', 'scintilla/RESearch.cxx',
 	'scintilla/RunStyles.cxx', 'scintilla/ScintillaBase.cxx', 'scintilla/ScintillaGTK.cxx',
 	'scintilla/scintilla-marshal.c', 'scintilla/StyleContext.cxx', 'scintilla/Style.cxx',
@@ -93,7 +107,7 @@
 	'src/geanymenubuttonaction.c', 'src/geanyobject.c', 'src/geanywraplabel.c',
 	'src/highlighting.c', 'src/interface.c', 'src/keybindings.c',
 	'src/keyfile.c', 'src/log.c', 'src/main.c', 'src/msgwindow.c', 'src/navqueue.c', 'src/notebook.c',
-	'src/plugins.c', 'src/prefix.c', 'src/prefs.c', 'src/printing.c', 'src/project.c',
+	'src/plugins.c', 'src/pluginutils.c', 'src/prefix.c', 'src/prefs.c', 'src/printing.c', 'src/project.c',
 	'src/queue.c', 'src/sciwrappers.c', 'src/search.c', 'src/socket.c', 'src/stash.c',
 	'src/symbols.c',
 	'src/templates.c', 'src/toolbar.c', 'src/tools.c', 'src/treeviews.c',
@@ -119,7 +133,8 @@
 		# try SVN
 		elif os.path.exists('.svn'):
 			try:
-				stdout = Utils.cmd_output(cmd='svn info --non-interactive', env={'LANG' : 'C'})
+				_env = None if is_win32 else {'LANG' : 'C'}
+				stdout = Utils.cmd_output(cmd='svn info --non-interactive', silent=True, env=_env)
 				lines = stdout.splitlines(True)
 				for line in lines:
 					if line.startswith('Last Changed Rev'):
@@ -139,7 +154,9 @@
 		elif default_value:
 			conf.define(define_name, default_value, quote)
 
+
 	conf.check_tool('compiler_cc')
+	is_win32 = target_is_win32(conf.env)
 
 	conf.check(header_name='fcntl.h')
 	conf.check(header_name='fnmatch.h')
@@ -171,12 +188,19 @@
 
 	# check for cxx after the header and function checks have been done to ensure they are
 	# checked with cc not cxx
-	conf.check_tool('compiler_cxx intltool misc')
-
+	conf.check_tool('compiler_cxx misc')
+	if is_win32:
+		conf.check_tool('winres')
+	# we don't require intltool on Windows (it would require Perl) though it works well
+	try:
+		conf.check_tool('intltool')
+	except:
+		pass
+
+
+	# GTK / GIO version check
 	conf.check_cfg(package='gtk+-2.0', atleast_version='2.8.0', uselib_store='GTK',
 		mandatory=True, args='--cflags --libs')
-
-	# GTK version check
 	have_gtk_210 = False
 	gtk_version = conf.check_cfg(modversion='gtk+-2.0', uselib_store='GTK')
 	if gtk_version:
@@ -184,20 +208,47 @@
 			have_gtk_210 = True
 	else:
 		gtk_version = 'Unknown'
-	# GIO check
 	conf.check_cfg(package='gio-2.0', uselib_store='GIO', args='--cflags --libs', mandatory=False)
 
-	conf_define_from_opt('LIBDIR', Options.options.libdir, conf.env['PREFIX'] + '/lib')
-	conf_define_from_opt('DOCDIR', Options.options.docdir, conf.env['DATADIR'] + '/doc/geany')
-	conf_define_from_opt('MANDIR', Options.options.mandir, conf.env['DATADIR'] + '/man')
+	# Windows specials
+	if is_win32:
+		if conf.env['PREFIX'] == tempfile.gettempdir():
+			# overwrite default prefix on Windows (tempfile.gettempdir() is the Waf default)
+			conf.define('PREFIX', os.path.join(conf.srcdir, '%s-%s' % (APPNAME, VERSION)), 1)
+		conf.define('DOCDIR', os.path.join(conf.env['PREFIX'], 'doc'), 1)
+		conf.define('LOCALEDIR', os.path.join(conf.env['PREFIX'], 'share\locale'), 1)
+		conf.define('LIBDIR', conf.env['PREFIX'], 1)
+		# DATADIR is defined in objidl.h, so we remove it from config.h but keep it in env
+		conf.undefine('DATADIR')
+		conf.env['DATADIR'] = os.path.join(conf.env['PREFIX'], 'data')
+		# hack: we add the parent directory of the first include directory as this is missing in
+		# list returned from pkg-config
+		conf.env['CPPPATH_GTK'].insert(0, os.path.dirname(conf.env['CPPPATH_GTK'][0]))
+		# we don't need -fPIC when compiling on or for Windows
+		if '-fPIC' in conf.env['shlib_CCFLAGS']:
+			conf.env['shlib_CCFLAGS'].remove('-fPIC')
+		if '-fPIC' in conf.env['CXXFLAGS']:
+			conf.env['CXXFLAGS'].remove('-fPIC')
+		conf.env.append_value('program_LINKFLAGS', '-mwindows')
+		conf.env.append_value('LIB_WIN32', [ 'wsock32', 'uuid', 'ole32', 'iberty' ])
+		conf.env['shlib_PATTERN'] = '%s.dll'
+		conf.env['program_PATTERN'] = '%s.exe'
+	else:
+		conf.env['shlib_PATTERN'] = '%s.so'
+		conf_define_from_opt('DOCDIR', Options.options.docdir,
+			os.path.join(conf.env['DATADIR'], 'doc/geany'))
+		conf_define_from_opt('LIBDIR', Options.options.libdir,
+			os.path.join(conf.env['PREFIX'], 'lib'))
+		conf_define_from_opt('MANDIR', Options.options.mandir,
+			os.path.join(conf.env['DATADIR'], 'man'))
 
 	svn_rev = conf_get_svn_rev()
 	conf.define('ENABLE_NLS', 1)
-	conf.define('GEANY_LOCALEDIR', 'LOCALEDIR', 0)
-	conf.define('GEANY_DATADIR', 'DATADIR', 0)
-	conf.define('GEANY_DOCDIR', 'DOCDIR', 0)
-	conf.define('GEANY_LIBDIR', 'LIBDIR', 0)
-	conf.define('GEANY_PREFIX', conf.env['PREFIX'], 1)
+	conf.define('GEANY_LOCALEDIR', '' if is_win32 else conf.env['LOCALEDIR'], 1)
+	conf.define('GEANY_DATADIR', 'data' if is_win32 else conf.env['DATADIR'], 1)
+	conf.define('GEANY_DOCDIR', conf.env['DOCDIR'], 1)
+	conf.define('GEANY_LIBDIR', '' if is_win32 else conf.env['LIBDIR'], 1)
+	conf.define('GEANY_PREFIX', '' if is_win32 else conf.env['PREFIX'], 1)
 	conf.define('PACKAGE', APPNAME, 1)
 	conf.define('VERSION', VERSION, 1)
 	conf.define('REVISION', svn_rev, 1)
@@ -222,61 +273,10 @@
 
 	conf.env.append_value('CCFLAGS', '-DHAVE_CONFIG_H')
 	# Scintilla flags
-	conf.env.append_value('CXXFLAGS', '-DNDEBUG -DGTK -DGTK2 -DSCI_LEXER -DG_THREADS_IMPL_NONE'.split())
+	conf.env.append_value('CXXFLAGS', 
+		'-DNDEBUG -DGTK -DGTK2 -DSCI_LEXER -DG_THREADS_IMPL_NONE'.split())
 
 
 def set_options(opt):
 	opt.tool_options('compiler_cc')
 	opt.tool_options('compiler_cxx')
-	opt.tool_options('intltool')
-
-	if 'configure' in sys.argv:
-		# Features
-		opt.add_option('--disable-plugins', action='store_true', default=False,
-			help='compile without plugin support [default: No]', dest='no_plugins')
-		opt.add_option('--disable-socket', action='store_true', default=False,
-			help='compile without support to detect a running instance [[default: No]', dest='no_socket')
-		opt.add_option('--disable-vte', action='store_true', default=False,
-			help='compile without support for an embedded virtual terminal [[default: No]', dest='no_vte')
-		opt.add_option('--enable-gnu-regex', action='store_true', default=False,
-			help='compile with included GNU regex library [default: No]', dest='gnu_regex')
-		# Paths
-		opt.add_option('--mandir', type='string', default='',
-			help='man documentation', dest='mandir')
-		opt.add_option('--docdir', type='string', default='',
-			help='documentation root', dest='docdir')
-		opt.add_option('--libdir', type='string', default='',
-			help='object code libraries', dest='libdir')
-	# Actions
-	opt.add_option('--htmldoc', action='store_true', default=False,
-		help='generate HTML documentation', dest='htmldoc')
-	opt.add_option('--apidoc', action='store_true', default=False,
-		help='generate API reference documentation', dest='apidoc')
-	opt.add_option('--update-po', action='store_true', default=False,
-		help='update the message catalogs for translation', dest='update_po')
-
-
-def build(bld):
-	def build_plugin(plugin_name, install = True):
-		if install:
-			instpath = '${LIBDIR}/geany/'
-		else:
-			instpath = None
-
-		bld.new_task_gen(
-			features				='cc cshlib',
-			source					= 'plugins/' + plugin_name + '.c',
-			includes				= '. plugins/ src/ scintilla/include tagmanager/include',
-			target					= plugin_name,
-			uselib					= 'GTK',
-			install_path			= instpath,
-		)
-		bld.env['shlib_PATTERN']	= '%s.so'
-
-
-	# Tagmanager
-	if bld.env['USE_INCLUDED_REGEX'] == 1:
-		tagmanager_sources.append('tagmanager/regex.c')
-	bld.new_task_gen(
-		features		= 'cc cstaticlib',
-		source			= tagmanager_sources,
