## geany 0.19.1

=== wscript ===
--- 
+++ 
@@ -3,8 +3,8 @@
 #
 # WAF build script - this file is part of Geany, a fast and lightweight IDE
 #
-# Copyright 2008-2009 Enrico Tröger <enrico(dot)troeger(at)uvena(dot)de>
-# Copyright 2008-2009 Nick Treleaven <nick(dot)treleaven(at)btinternet(dot)com>
+# Copyright 2008-2010 Enrico Tröger <enrico(dot)troeger(at)uvena(dot)de>
+# Copyright 2008-2010 Nick Treleaven <nick(dot)treleaven(at)btinternet(dot)com>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,7 +20,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
-# $Id: wscript 4079 2009-08-13 21:59:33Z eht16 $
+# $Id: wscript 5165 2010-08-16 11:22:45Z ntrel $
 
 """
 This is a WAF build script (http://code.google.com/p/waf/).
@@ -35,7 +35,7 @@
 Known issues: Dependency handling is buggy, e.g. if src/document.h is
 			  changed, depending source files are not rebuilt (maybe Waf bug).
 
-The code of this file itself loosely follows PEP 8 with some exceptions 
+The code of this file itself loosely follows PEP 8 with some exceptions
 (line width 100 characters and some other minor things).
 
 Requires WAF 1.5.7 and Python 2.4 (or later).
@@ -51,17 +51,18 @@
 import shutil
 import tempfile
 from distutils import version
+from TaskGen import taskgen, feature
 
 
 APPNAME = 'geany'
-VERSION = '0.18'
+VERSION = '0.19.1'
 
 srcdir = '.'
 blddir = '_build_'
 
 
 tagmanager_sources = [
-	'tagmanager/args.c', 'tagmanager/actionscript.c', 'tagmanager/asm.c',
+	'tagmanager/args.c', 'tagmanager/abc.c', 'tagmanager/actionscript.c', 'tagmanager/asm.c',
 	'tagmanager/basic.c', 'tagmanager/c.c',
 	'tagmanager/conf.c', 'tagmanager/css.c', 'tagmanager/ctags.c', 'tagmanager/diff.c',
 	'tagmanager/docbook.c', 'tagmanager/entry.c', 'tagmanager/fortran.c', 'tagmanager/get.c',
@@ -69,13 +70,14 @@
 	'tagmanager/keyword.c', 'tagmanager/latex.c', 'tagmanager/lregex.c', 'tagmanager/lua.c',
 	'tagmanager/make.c', 'tagmanager/markdown.c', 'tagmanager/matlab.c', 'tagmanager/nsis.c',
 	'tagmanager/nestlevel.c', 'tagmanager/options.c',
-	'tagmanager/parse.c', 'tagmanager/pascal.c',
+	'tagmanager/parse.c', 'tagmanager/pascal.c', 'tagmanager/r.c',
 	'tagmanager/perl.c', 'tagmanager/php.c', 'tagmanager/python.c', 'tagmanager/read.c',
 	'tagmanager/rest.c', 'tagmanager/ruby.c', 'tagmanager/sh.c', 'tagmanager/sort.c',
-	'tagmanager/sql.c', 'tagmanager/strlist.c', 'tagmanager/tcl.c', 'tagmanager/tm_file_entry.c',
+	'tagmanager/sql.c', 'tagmanager/strlist.c', 'tagmanager/txt2tags.c', 'tagmanager/tcl.c',
+	'tagmanager/tm_file_entry.c',
 	'tagmanager/tm_project.c', 'tagmanager/tm_source_file.c', 'tagmanager/tm_symbol.c',
 	'tagmanager/tm_tag.c', 'tagmanager/tm_tagmanager.c', 'tagmanager/tm_work_object.c',
-	'tagmanager/tm_workspace.c', 'tagmanager/vhdl.c', 'tagmanager/vstring.c' ]
+	'tagmanager/tm_workspace.c', 'tagmanager/vhdl.c', 'tagmanager/verilog.c', 'tagmanager/vstring.c' ]
 
 scintilla_sources = [
 	'scintilla/AutoComplete.cxx', 'scintilla/CallTip.cxx', 'scintilla/CellBuffer.cxx',
@@ -85,19 +87,19 @@
 	'scintilla/KeyWords.cxx',
 	'scintilla/LexAda.cxx', 'scintilla/LexAsm.cxx', 'scintilla/LexBash.cxx',
 	'scintilla/LexBasic.cxx', 'scintilla/LexCaml.cxx', 'scintilla/LexCmake.cxx', 'scintilla/LexCPP.cxx',
-	'scintilla/LexCrontab.cxx', 'scintilla/LexCSS.cxx', 'scintilla/LexD.cxx',
+	'scintilla/LexCSS.cxx', 'scintilla/LexD.cxx',
 	'scintilla/LexFortran.cxx', 'scintilla/LexHaskell.cxx', 'scintilla/LexHTML.cxx',
 	'scintilla/LexLua.cxx', 'scintilla/LexMarkdown.cxx', 'scintilla/LexMatlab.cxx',
 	'scintilla/LexNsis.cxx', 'scintilla/LexOthers.cxx',
 	'scintilla/LexPascal.cxx', 'scintilla/LexPerl.cxx', 'scintilla/LexPython.cxx',
 	'scintilla/LexR.cxx',
 	'scintilla/LexRuby.cxx', 'scintilla/LexSQL.cxx', 'scintilla/LexTCL.cxx',
-	'scintilla/LexVHDL.cxx', 'scintilla/LexYAML.cxx',
+	'scintilla/LexVHDL.cxx', 'scintilla/LexVerilog.cxx', 'scintilla/LexYAML.cxx',
 	'scintilla/LineMarker.cxx', 'scintilla/PerLine.cxx',
 	'scintilla/PlatGTK.cxx',
 	'scintilla/PositionCache.cxx', 'scintilla/PropSet.cxx', 'scintilla/RESearch.cxx',
 	'scintilla/RunStyles.cxx', 'scintilla/ScintillaBase.cxx', 'scintilla/ScintillaGTK.cxx',
-	'scintilla/scintilla-marshal.c', 'scintilla/StyleContext.cxx', 'scintilla/Style.cxx',
+	'scintilla/scintilla-marshal.c', 'scintilla/Selection.cxx', 'scintilla/StyleContext.cxx', 'scintilla/Style.cxx',
 	'scintilla/UniConversion.cxx', 'scintilla/ViewStyle.cxx', 'scintilla/WindowAccessor.cxx',
 	'scintilla/XPM.cxx' ]
 
@@ -108,21 +110,29 @@
 	'src/highlighting.c', 'src/interface.c', 'src/keybindings.c',
 	'src/keyfile.c', 'src/log.c', 'src/main.c', 'src/msgwindow.c', 'src/navqueue.c', 'src/notebook.c',
 	'src/plugins.c', 'src/pluginutils.c', 'src/prefix.c', 'src/prefs.c', 'src/printing.c', 'src/project.c',
-	'src/queue.c', 'src/sciwrappers.c', 'src/search.c', 'src/socket.c', 'src/stash.c',
+	'src/sciwrappers.c', 'src/search.c', 'src/socket.c', 'src/stash.c',
 	'src/symbols.c',
-	'src/templates.c', 'src/toolbar.c', 'src/tools.c', 'src/treeviews.c',
+	'src/templates.c', 'src/toolbar.c', 'src/tools.c', 'src/sidebar.c',
 	'src/ui_utils.c', 'src/utils.c' ]
 
 
 
 def configure(conf):
+	def in_git():
+		cmd = 'git ls-files >/dev/null 2>&1'
+		return (Utils.exec_command(cmd) == 0)
+
+	def in_svn():
+		return os.path.exists('.svn')
+
 	def conf_get_svn_rev():
 		# try GIT
-		if os.path.exists('.git'):
+		if in_git():
 			cmds = [ 'git svn find-rev HEAD 2>/dev/null',
 					 'git svn find-rev origin/trunk 2>/dev/null',
 					 'git svn find-rev trunk 2>/dev/null',
-					 'git svn find-rev master 2>/dev/null' ]
+					 'git svn find-rev master 2>/dev/null'
+					]
 			for c in cmds:
 				try:
 					stdout = Utils.cmd_output(c)
@@ -131,7 +141,7 @@
 				except:
 					pass
 		# try SVN
-		elif os.path.exists('.svn'):
+		elif in_svn():
 			try:
 				_env = None if is_win32 else {'LANG' : 'C'}
 				stdout = Utils.cmd_output(cmd='svn info --non-interactive', silent=True, env=_env)
@@ -186,6 +196,11 @@
 	conf.check(function_name='mkstemp', header_name='stdlib.h')
 	conf.check(function_name='strstr', header_name='string.h', mandatory=True)
 
+	# check sunOS socket support
+	if Options.platform == 'sunos':
+		conf.check(function_name='socket', lib='socket',
+			header_name='sys/socket.h', uselib_store='SUNOS_SOCKET', mandatory=True)
+
 	# check for cxx after the header and function checks have been done to ensure they are
 	# checked with cc not cxx
 	conf.check_tool('compiler_cxx misc')
@@ -194,9 +209,11 @@
 	# we don't require intltool on Windows (it would require Perl) though it works well
 	try:
 		conf.check_tool('intltool')
-	except:
-		pass
-
+		if 'LINGUAS' in os.environ:
+			conf.env['LINGUAS'] = os.environ['LINGUAS']
+	except Configure.ConfigurationError:
+		if not is_win32:
+			raise
 
 	# GTK / GIO version check
 	conf.check_cfg(package='gtk+-2.0', atleast_version='2.8.0', uselib_store='GTK',
@@ -265,18 +282,3 @@
 	print_message(conf, 'Install Geany ' + VERSION + ' in', conf.env['PREFIX'])
 	print_message(conf, 'Using GTK version', gtk_version)
 	print_message(conf, 'Build with GTK printing support', have_gtk_210 and 'yes' or 'no')
-	print_message(conf, 'Build with plugin support', Options.options.no_plugins and 'no' or 'yes')
-	print_message(conf, 'Use virtual terminal support', Options.options.no_vte and 'no' or 'yes')
-	if svn_rev != '-1':
-		print_message(conf, 'Compiling Subversion revision', svn_rev)
-		conf.env.append_value('CCFLAGS', '-g -DGEANY_DEBUG'.split())
-
-	conf.env.append_value('CCFLAGS', '-DHAVE_CONFIG_H')
-	# Scintilla flags
-	conf.env.append_value('CXXFLAGS', 
-		'-DNDEBUG -DGTK -DGTK2 -DSCI_LEXER -DG_THREADS_IMPL_NONE'.split())
-
-
-def set_options(opt):
-	opt.tool_options('compiler_cc')
-	opt.tool_options('compiler_cxx')
